using System;
using System.IO;

namespace LuceneNet.Analysis.Standard
{
	public class StandardTokenizerTokenManager
	{
		public  TextWriter debugStream = Console.Out;
		public  void setDebugStream(TextWriter ds) { debugStream = ds; }
		private int jjMoveStringLiteralDfa0_0()
		{
			return jjMoveNfa_0(1, 0);
		}
		private void jjCheckNAdd(int state)
		{
			if (jjrounds[state] != jjround)
			{
				jjstateSet[jjnewStateCnt++] = (uint)state;
				jjrounds[state] = jjround;
			}
		}
		private void jjAddStates(int start, int end)
		{
			do 
			{
				jjstateSet[jjnewStateCnt++] = (uint)jjnextStates[start];
			} while (start++ != end);
		}
		private void jjCheckNAddTwoStates(int state1, int state2)
		{
			jjCheckNAdd(state1);
			jjCheckNAdd(state2);
		}
		private void jjCheckNAddStates(int start, int end)
		{
			do 
			{
				jjCheckNAdd(jjnextStates[start]);
			} while (start++ != end);
		}
		private void jjCheckNAddStates(int start)
		{
			jjCheckNAdd(jjnextStates[start]);
			jjCheckNAdd(jjnextStates[start + 1]);
		}
		static readonly ulong[] jjbitVec0 = {
									   0x1ff0000000000000L, 0xffffffffffffc000L, 0xffffffffL, 0x600000000000000L
								   };
		static readonly ulong[] jjbitVec2 = {
									   0x0L, 0xffffffffffffffffL, 0xffffffffffffffffL, 0xffffffffffffffffL
								   };
		static readonly ulong[] jjbitVec3 = {
									   0xffffffffffffffffL, 0xffffffffffffffffL, 0xffffL, 0x0L
								   };
		static readonly ulong[] jjbitVec4 = {
									   0xffffffffffffffffL, 0xffffffffffffffffL, 0x0L, 0x0L
								   };
		static readonly ulong[] jjbitVec5 = {
									   0x3fffffffffffL, 0x0L, 0x0L, 0x0L
								   };
		static readonly ulong[] jjbitVec6 = {
									   0x1600L, 0x0L, 0x0L, 0x0L
								   };
		static readonly ulong[] jjbitVec7 = {
									   0x0L, 0xffc000000000L, 0x0L, 0xffc000000000L
								   };
		static readonly ulong[] jjbitVec8 = {
									   0x0L, 0x3ff00000000L, 0x0L, 0x3ff000000000000L
								   };
		static readonly ulong[] jjbitVec9 = {
									   0x0L, 0xffc000000000L, 0x0L, 0xff8000000000L
								   };
		static readonly ulong[] jjbitVec10 = {
										0x0L, 0xffc000000000L, 0x0L, 0x0L
									};
		static readonly ulong[] jjbitVec11 = {
										0x0L, 0x3ff0000L, 0x0L, 0x3ff0000L
									};
		static readonly ulong[] jjbitVec12 = {
										0x0L, 0x3ffL, 0x0L, 0x0L
									};
		static readonly ulong[] jjbitVec13 = {
										0xfffffffeL, 0x0L, 0x0L, 0x0L
									};
		static readonly ulong[] jjbitVec14 = {
										0x0L, 0x0L, 0x0L, 0xff7fffffff7fffffL
									};
		private int jjMoveNfa_0(int startState, int curPos)
		{
			int startsAt = 0;
			jjnewStateCnt = 73;
			int i = 1;
			jjstateSet[0] = (uint)startState;
			int kind = 0x7fffffff;
			for (;;)
			{
				if (++jjround == 0x7fffffff)
					ReInitRounds();
				if (curChar < 64)
				{
					long l = 1L << curChar;
				do
						   {
							   switch(jjstateSet[--i])
							   {
								   case 1:
									   if ((0x3ff000000000000L & l) != 0L)
									   {
										   if (kind > 1)
											   kind = 1;
										   jjCheckNAddStates(0, 17);
									   }
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddStates(18, 23);
									   break;
								   case 2:
								   case 39:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(2, 3);
									   break;
								   case 3:
									   if ((0xf00000000000L & l) != 0L)
										   jjCheckNAdd(4);
									   break;
								   case 4:
									   if ((0x3ff000000000000L & l) == 0L)
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAdd(4);
									   break;
								   case 5:
								   case 48:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(5, 6);
									   break;
								   case 6:
									   if ((0xf00000000000L & l) != 0L)
										   jjCheckNAdd(7);
									   break;
								   case 7:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(7, 8);
									   break;
								   case 8:
									   if ((0xf00000000000L & l) != 0L)
										   jjCheckNAddTwoStates(9, 10);
									   break;
								   case 9:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(9, 10);
									   break;
								   case 10:
								   case 11:
									   if ((0x3ff000000000000L & l) == 0L)
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(6, 11);
									   break;
								   case 12:
								   case 61:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(12, 13);
									   break;
								   case 13:
									   if ((0xf00000000000L & l) != 0L)
										   jjCheckNAdd(14);
									   break;
								   case 14:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(14, 15);
									   break;
								   case 15:
									   if ((0xf00000000000L & l) != 0L)
										   jjCheckNAddTwoStates(16, 17);
									   break;
								   case 16:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(16, 17);
									   break;
								   case 17:
								   case 18:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(18, 19);
									   break;
								   case 19:
									   if ((0xf00000000000L & l) != 0L)
										   jjCheckNAdd(20);
									   break;
								   case 20:
									   if ((0x3ff000000000000L & l) == 0L)
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(15, 20);
									   break;
								   case 21:
									   if ((0x3ff000000000000L & l) == 0L)
										   break;
									   if (kind > 1)
										   kind = 1;
									   jjCheckNAddStates(0, 17);
									   break;
								   case 22:
									   if ((0x3ff000000000000L & l) == 0L)
										   break;
									   if (kind > 1)
										   kind = 1;
									   jjCheckNAdd(22);
									   break;
								   case 23:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddStates(24, 26);
									   break;
								   case 24:
									   if ((0x600000000000L & l) != 0L)
										   jjCheckNAdd(25);
									   break;
								   case 25:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddStates(27, 29);
									   break;
								   case 27:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(27, 28);
									   break;
								   case 28:
									   if ((0x600000000000L & l) != 0L)
										   jjCheckNAdd(29);
									   break;
								   case 29:
									   if ((0x3ff000000000000L & l) == 0L)
										   break;
									   if (kind > 5)
										   kind = 5;
									   jjCheckNAddTwoStates(28, 29);
									   break;
								   case 30:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(30, 31);
									   break;
								   case 31:
									   if (curChar == 46)
										   jjCheckNAdd(32);
									   break;
								   case 32:
									   if ((0x3ff000000000000L & l) == 0L)
										   break;
									   if (kind > 6)
										   kind = 6;
									   jjCheckNAddTwoStates(31, 32);
									   break;
								   case 33:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(33, 34);
									   break;
								   case 34:
									   if ((0xf00000000000L & l) != 0L)
										   jjCheckNAddTwoStates(35, 36);
									   break;
								   case 35:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(35, 36);
									   break;
								   case 36:
								   case 37:
									   if ((0x3ff000000000000L & l) == 0L)
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAdd(37);
									   break;
								   case 38:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(38, 39);
									   break;
								   case 40:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(40, 41);
									   break;
								   case 41:
									   if ((0xf00000000000L & l) != 0L)
										   jjCheckNAddTwoStates(42, 43);
									   break;
								   case 42:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(42, 43);
									   break;
								   case 43:
								   case 44:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(44, 45);
									   break;
								   case 45:
									   if ((0xf00000000000L & l) != 0L)
										   jjCheckNAdd(46);
									   break;
								   case 46:
									   if ((0x3ff000000000000L & l) == 0L)
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(41, 46);
									   break;
								   case 47:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(47, 48);
									   break;
								   case 49:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(49, 50);
									   break;
								   case 50:
									   if ((0xf00000000000L & l) != 0L)
										   jjCheckNAddTwoStates(51, 52);
									   break;
								   case 51:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(51, 52);
									   break;
								   case 52:
								   case 53:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(53, 54);
									   break;
								   case 54:
									   if ((0xf00000000000L & l) != 0L)
										   jjCheckNAdd(55);
									   break;
								   case 55:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(55, 56);
									   break;
								   case 56:
									   if ((0xf00000000000L & l) != 0L)
										   jjCheckNAddTwoStates(57, 58);
									   break;
								   case 57:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(57, 58);
									   break;
								   case 58:
								   case 59:
									   if ((0x3ff000000000000L & l) == 0L)
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(54, 59);
									   break;
								   case 60:
									   if ((0x3ff000000000000L & l) != 0L)
										   jjCheckNAddTwoStates(60, 61);
									   break;
								   case 64:
									   if (curChar == 39)
										   jjstateSet[jjnewStateCnt++] = 65;
									   break;
								   case 67:
									   if (curChar == 46)
										   jjCheckNAdd(68);
									   break;
								   case 69:
									   if (curChar != 46)
										   break;
									   if (kind > 3)
										   kind = 3;
									   jjCheckNAdd(68);
									   break;
								   case 71:
									   if (curChar == 38)
										   jjstateSet[jjnewStateCnt++] = 72;
									   break;
								   default : break;
							   }
						   } while(i != startsAt);
				}
				else if (curChar < 128)
				{
					long l = 1L << (curChar & 63);
				do
						   {
							   switch(jjstateSet[--i])
							   {
								   case 1:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddStates(30, 35);
									   if ((0x7fffffe07fffffeL & l) != 0L)
									   {
										   if (kind > 1)
											   kind = 1;
										   jjCheckNAddStates(0, 17);
									   }
									   break;
								   case 2:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjAddStates(36, 37);
									   break;
								   case 3:
									   if (curChar == 95)
										   jjCheckNAdd(4);
									   break;
								   case 4:
									   if ((0x7fffffe07fffffeL & l) == 0L)
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAdd(4);
									   break;
								   case 5:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(5, 6);
									   break;
								   case 6:
									   if (curChar == 95)
										   jjCheckNAdd(7);
									   break;
								   case 7:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(7, 8);
									   break;
								   case 8:
									   if (curChar == 95)
										   jjCheckNAddTwoStates(9, 10);
									   break;
								   case 9:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(9, 10);
									   break;
								   case 11:
									   if ((0x7fffffe07fffffeL & l) == 0L)
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(6, 11);
									   break;
								   case 12:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjAddStates(38, 39);
									   break;
								   case 13:
									   if (curChar == 95)
										   jjCheckNAdd(14);
									   break;
								   case 14:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(14, 15);
									   break;
								   case 15:
									   if (curChar == 95)
										   jjCheckNAddTwoStates(16, 17);
									   break;
								   case 16:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(16, 17);
									   break;
								   case 18:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjAddStates(40, 41);
									   break;
								   case 19:
									   if (curChar == 95)
										   jjCheckNAdd(20);
									   break;
								   case 20:
									   if ((0x7fffffe07fffffeL & l) == 0L)
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(15, 20);
									   break;
								   case 21:
									   if ((0x7fffffe07fffffeL & l) == 0L)
										   break;
									   if (kind > 1)
										   kind = 1;
									   jjCheckNAddStates(0, 17);
									   break;
								   case 22:
									   if ((0x7fffffe07fffffeL & l) == 0L)
										   break;
									   if (kind > 1)
										   kind = 1;
									   jjCheckNAdd(22);
									   break;
								   case 23:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddStates(24, 26);
									   break;
								   case 24:
									   if (curChar == 95)
										   jjCheckNAdd(25);
									   break;
								   case 25:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddStates(27, 29);
									   break;
								   case 26:
									   if (curChar == 64)
										   jjCheckNAdd(27);
									   break;
								   case 27:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(27, 28);
									   break;
								   case 29:
									   if ((0x7fffffe07fffffeL & l) == 0L)
										   break;
									   if (kind > 5)
										   kind = 5;
									   jjCheckNAddTwoStates(28, 29);
									   break;
								   case 30:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(30, 31);
									   break;
								   case 32:
									   if ((0x7fffffe07fffffeL & l) == 0L)
										   break;
									   if (kind > 6)
										   kind = 6;
									   jjCheckNAddTwoStates(31, 32);
									   break;
								   case 33:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(33, 34);
									   break;
								   case 34:
									   if (curChar == 95)
										   jjCheckNAddTwoStates(35, 36);
									   break;
								   case 35:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(35, 36);
									   break;
								   case 37:
									   if ((0x7fffffe07fffffeL & l) == 0L)
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjstateSet[jjnewStateCnt++] = 37;
									   break;
								   case 38:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(38, 39);
									   break;
								   case 40:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(40, 41);
									   break;
								   case 41:
									   if (curChar == 95)
										   jjCheckNAddTwoStates(42, 43);
									   break;
								   case 42:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(42, 43);
									   break;
								   case 44:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjAddStates(42, 43);
									   break;
								   case 45:
									   if (curChar == 95)
										   jjCheckNAdd(46);
									   break;
								   case 46:
									   if ((0x7fffffe07fffffeL & l) == 0L)
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(41, 46);
									   break;
								   case 47:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(47, 48);
									   break;
								   case 49:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(49, 50);
									   break;
								   case 50:
									   if (curChar == 95)
										   jjCheckNAddTwoStates(51, 52);
									   break;
								   case 51:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(51, 52);
									   break;
								   case 53:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(53, 54);
									   break;
								   case 54:
									   if (curChar == 95)
										   jjCheckNAdd(55);
									   break;
								   case 55:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(55, 56);
									   break;
								   case 56:
									   if (curChar == 95)
										   jjCheckNAddTwoStates(57, 58);
									   break;
								   case 57:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(57, 58);
									   break;
								   case 59:
									   if ((0x7fffffe07fffffeL & l) == 0L)
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(54, 59);
									   break;
								   case 60:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(60, 61);
									   break;
								   case 62:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddStates(30, 35);
									   break;
								   case 63:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(63, 64);
									   break;
								   case 65:
									   if ((0x7fffffe07fffffeL & l) == 0L)
										   break;
									   if (kind > 2)
										   kind = 2;
									   jjCheckNAddTwoStates(64, 65);
									   break;
								   case 66:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(66, 67);
									   break;
								   case 68:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjAddStates(44, 45);
									   break;
								   case 70:
									   if ((0x7fffffe07fffffeL & l) != 0L)
										   jjCheckNAddTwoStates(70, 71);
									   break;
								   case 71:
									   if (curChar == 64)
										   jjCheckNAdd(72);
									   break;
								   case 72:
									   if ((0x7fffffe07fffffeL & l) == 0L)
										   break;
									   if (kind > 4)
										   kind = 4;
									   jjCheckNAdd(72);
									   break;
								   default : break;
							   }
						   } while(i != startsAt);
				}
				else
				{
					int hiByte = (int)(curChar >> 8);
					int i1 = hiByte >> 6;
					long l1 = 1L << (hiByte & 63);
					int i2 = (curChar & 0xff) >> 6;
					long l2 = 1L << (curChar & 63);
				do
						   {
							   switch(jjstateSet[--i])
							   {
								   case 1:
									   if (jjCanMove_0(hiByte, i1, i2, l1, l2))
									   {
										   if (kind > 10)
											   kind = 10;
										   jjCheckNAdd(0);
									   }
									   if (jjCanMove_1(hiByte, i1, i2, l1, l2))
										   jjCheckNAddStates(18, 23);
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
									   {
										   if (kind > 1)
											   kind = 1;
										   jjCheckNAddStates(0, 17);
									   }
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddStates(30, 35);
									   break;
								   case 0:
									   if (!jjCanMove_0(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 10)
										   kind = 10;
									   jjCheckNAdd(0);
									   break;
								   case 2:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(2, 3);
									   break;
								   case 4:
									   if (!jjCanMove_2(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjstateSet[jjnewStateCnt++] = 4;
									   break;
								   case 5:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(5, 6);
									   break;
								   case 7:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjAddStates(46, 47);
									   break;
								   case 9:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjAddStates(48, 49);
									   break;
								   case 10:
									   if (!jjCanMove_1(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(6, 11);
									   break;
								   case 11:
									   if (!jjCanMove_2(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(6, 11);
									   break;
								   case 12:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(12, 13);
									   break;
								   case 14:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(14, 15);
									   break;
								   case 16:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjAddStates(50, 51);
									   break;
								   case 17:
									   if (jjCanMove_1(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(18, 19);
									   break;
								   case 18:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(18, 19);
									   break;
								   case 20:
									   if (!jjCanMove_2(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(15, 20);
									   break;
								   case 21:
									   if (!jjCanMove_2(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 1)
										   kind = 1;
									   jjCheckNAddStates(0, 17);
									   break;
								   case 22:
									   if (!jjCanMove_2(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 1)
										   kind = 1;
									   jjCheckNAdd(22);
									   break;
								   case 23:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddStates(24, 26);
									   break;
								   case 25:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddStates(27, 29);
									   break;
								   case 27:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(27, 28);
									   break;
								   case 29:
									   if (!jjCanMove_2(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 5)
										   kind = 5;
									   jjCheckNAddTwoStates(28, 29);
									   break;
								   case 30:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(30, 31);
									   break;
								   case 32:
									   if (!jjCanMove_2(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 6)
										   kind = 6;
									   jjCheckNAddTwoStates(31, 32);
									   break;
								   case 33:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(33, 34);
									   break;
								   case 35:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjAddStates(52, 53);
									   break;
								   case 36:
									   if (!jjCanMove_1(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAdd(37);
									   break;
								   case 37:
									   if (!jjCanMove_2(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAdd(37);
									   break;
								   case 38:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(38, 39);
									   break;
								   case 39:
									   if (jjCanMove_1(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(2, 3);
									   break;
								   case 40:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(40, 41);
									   break;
								   case 42:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjAddStates(54, 55);
									   break;
								   case 43:
									   if (jjCanMove_1(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(44, 45);
									   break;
								   case 44:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(44, 45);
									   break;
								   case 46:
									   if (!jjCanMove_2(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(41, 46);
									   break;
								   case 47:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(47, 48);
									   break;
								   case 48:
									   if (jjCanMove_1(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(5, 6);
									   break;
								   case 49:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(49, 50);
									   break;
								   case 51:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjAddStates(56, 57);
									   break;
								   case 52:
									   if (jjCanMove_1(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(53, 54);
									   break;
								   case 53:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(53, 54);
									   break;
								   case 55:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjAddStates(58, 59);
									   break;
								   case 57:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjAddStates(60, 61);
									   break;
								   case 58:
									   if (!jjCanMove_1(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(54, 59);
									   break;
								   case 59:
									   if (!jjCanMove_2(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 7)
										   kind = 7;
									   jjCheckNAddTwoStates(54, 59);
									   break;
								   case 60:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(60, 61);
									   break;
								   case 61:
									   if (jjCanMove_1(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(12, 13);
									   break;
								   case 62:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddStates(30, 35);
									   break;
								   case 63:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(63, 64);
									   break;
								   case 65:
									   if (!jjCanMove_2(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 2)
										   kind = 2;
									   jjCheckNAddTwoStates(64, 65);
									   break;
								   case 66:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(66, 67);
									   break;
								   case 68:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjAddStates(44, 45);
									   break;
								   case 70:
									   if (jjCanMove_2(hiByte, i1, i2, l1, l2))
										   jjCheckNAddTwoStates(70, 71);
									   break;
								   case 72:
									   if (!jjCanMove_2(hiByte, i1, i2, l1, l2))
										   break;
									   if (kind > 4)
										   kind = 4;
									   jjstateSet[jjnewStateCnt++] = 72;
									   break;
								   default : break;
							   }
						   } while(i != startsAt);
				}
				if (kind != 0x7fffffff)
				{
					jjmatchedKind = kind;
					jjmatchedPos = curPos;
					kind = 0x7fffffff;
				}
				++curPos;
				if ((i = jjnewStateCnt) == (startsAt = 73 - (jjnewStateCnt = startsAt)))
					return curPos;
				try { curChar = input_stream.ReadChar(); }
				catch(IOException) { return curPos; }
			}
		}
		static int[] jjnextStates = {
										 22, 23, 24, 26, 30, 31, 33, 34, 38, 39, 40, 41, 47, 48, 49, 50, 
										 60, 61, 2, 3, 5, 6, 12, 13, 23, 24, 26, 24, 25, 26, 63, 64, 
										 66, 67, 70, 71, 2, 3, 12, 13, 18, 19, 44, 45, 68, 69, 7, 8, 
										 9, 10, 16, 17, 35, 36, 42, 43, 51, 52, 55, 56, 57, 58, 
		};
		private static bool jjCanMove_0(int hiByte, int i1, int i2, long l1, long l2)
		{
			switch(hiByte)
			{
				case 48:
					return ((jjbitVec2[i2] & 2) != 0L);
				case 49:
					return ((jjbitVec3[i2] & 2) != 0L);
				case 51:
					return ((jjbitVec4[i2] & 2) != 0L);
				case 61:
					return ((jjbitVec5[i2] & 2) != 0L);
				default : 
					if ((jjbitVec0[i1] & 1) != 0L)
						return true;
					return false;
			}
		}
		private static bool jjCanMove_1(int hiByte, int i1, int i2, long l1, long l2)
		{
			switch(hiByte)
			{
				case 6:
					return ((jjbitVec8[i2] & 2) != 0L);
				case 11:
					return ((jjbitVec9[i2] & 2) != 0L);
				case 13:
					return ((jjbitVec10[i2] & 2) != 0L);
				case 14:
					return ((jjbitVec11[i2] & 2) != 0L);
				case 16:
					return ((jjbitVec12[i2] & 2) != 0L);
				default : 
					if ((jjbitVec6[i1] & 1) != 0L)
						if ((jjbitVec7[i2] & 2) == 0L)
							return false;
						else
							return true;
					return false;
			}
		}
		private static bool jjCanMove_2(int hiByte, int i1, int i2, long l1, long l2)
		{
			switch(hiByte)
			{
				case 0:
					return ((jjbitVec14[i2] & 2) != 0L);
				default : 
					if ((jjbitVec13[i1] & 1) != 0L)
						return true;
					return false;
			}
		}
		public static String[] jjstrLiteralImages = 
	{
		"", null, null, null, null, null, null, null, null, null, null, null, null, 
		null, null, null, };
		public static String[] lexStateNames = 
	{
		"DEFAULT", 
		};
		static readonly long[] jjtoToken = {
												0x4ffL, 
		};
		static readonly long[] jjtoSkip = {
											   0x8000L, 
		};
		protected CharStream input_stream;
		private readonly uint[] jjrounds = new uint[73];
		private readonly uint[] jjstateSet = new uint[146];
		protected char curChar;
		public StandardTokenizerTokenManager(CharStream stream)
		{
			input_stream = stream;
		}
		public StandardTokenizerTokenManager(CharStream stream, int lexState)
		{
			input_stream = stream;
			SwitchTo(lexState);
		}
		public void ReInit(CharStream stream)
		{
			jjmatchedPos = jjnewStateCnt = 0;
			curLexState = defaultLexState;
			input_stream = stream;
			ReInitRounds();
		}
		private void ReInitRounds()
		{
			int i;
			jjround = 0x80000001;
			for (i = 73; i-- > 0;)
				jjrounds[i] = 0x80000000;
		}
		public void ReInit(CharStream stream, int lexState)
		{
			ReInit(stream);
			SwitchTo(lexState);
		}
		public void SwitchTo(int lexState)
		{
			if (lexState >= 1 || lexState < 0)
				throw new TokenMgrError("Error: Ignoring invalid lexical state : " + lexState + ". State unchanged.", TokenMgrError.INVALID_LEXICAL_STATE);
			else
				curLexState = lexState;
		}

		protected Token jjFillToken()
		{
			Token t = Token.NewToken(jjmatchedKind);
			t.kind = jjmatchedKind;
			String im = jjstrLiteralImages[jjmatchedKind];
			t.image = (im == null) ? input_stream.GetImage() : im;
			t.beginLine = input_stream.GetBeginLine();
			t.beginColumn = input_stream.GetBeginColumn();
			t.endLine = input_stream.GetEndLine();
			t.endColumn = input_stream.GetEndColumn();
			return t;
		}

		int curLexState = 0;
		int defaultLexState = 0;
		int jjnewStateCnt;
		uint jjround;
		int jjmatchedPos;
		int jjmatchedKind;

		public Token GetNextToken() 
		{
			Token matchedToken;
			int curPos = 0;

			EOFLoop :
				for (;;)
				{   
					try   
					{     
						curChar = input_stream.BeginToken();
					}     
					catch(IOException)
					{        
						jjmatchedKind = 0;
						matchedToken = jjFillToken();
						return matchedToken;
					}

					jjmatchedKind = 0x7fffffff;
					jjmatchedPos = 0;
					curPos = jjMoveStringLiteralDfa0_0();
					if (jjmatchedPos == 0 && jjmatchedKind > 15)
					{
						jjmatchedKind = 15;
					}
					if (jjmatchedKind != 0x7fffffff)
					{
						if (jjmatchedPos + 1 < curPos)
							input_stream.Backup(curPos - jjmatchedPos - 1);
						if ((jjtoToken[jjmatchedKind >> 6] & (1L << (jjmatchedKind & 63))) != 0L)
						{
							matchedToken = jjFillToken();
							return matchedToken;
						}
						else
						{
							goto EOFLoop;
						}
					}
					int error_line = input_stream.GetEndLine();
					int error_column = input_stream.GetEndColumn();
					String error_after = null;
					bool EOFSeen = false;
					try { input_stream.ReadChar(); input_stream.Backup(1); }
					catch (IOException) 
					{
						EOFSeen = true;
						error_after = curPos <= 1 ? "" : input_stream.GetImage();
						if (curChar == '\n' || curChar == '\r') 
						{
							error_line++;
							error_column = 0;
						}
						else
							error_column++;
					}
					if (!EOFSeen) 
					{
						input_stream.Backup(1);
						error_after = curPos <= 1 ? "" : input_stream.GetImage();
					}
					throw new TokenMgrError(EOFSeen, curLexState, error_line, error_column, error_after, curChar, TokenMgrError.LEXICAL_ERROR);
				}
		}

	}
}